# pqxx::result::tuple Class Reference

Reference to one row in a result. More...

`#include <result.hxx>`

Inheritance diagram for pqxx::result::tuple:

[legend]
List of all members.

## Public Types

typedef unsigned int | size_type
typedef signed int | difference_type
typedef const_fielditerator | const_iterator
typedef field | reference
typedef const_fielditerator | pointer
typedef const_reverse_fielditerator | const_reverse_iterator

## Public Member Functions

| tuple (const result *r, result::size_type i) throw ()
| ~tuple () throw ()
const_iterator | begin () const throw ()
const_iterator | end () const throw ()
size_type | size () const throw ()
void | swap (tuple &) throw ()
result::size_type | rownumber () const throw ()
result::size_type | num () const
Comparison
bool | operator== (const tuple &) const throw ()
bool | operator!= (const tuple &rhs) const throw ()
Field access
reference | front () const throw ()
reference | back () const throw ()
const_reverse_fielditerator | rbegin () const
const_reverse_fielditerator | rend () const
reference | operator[] (size_type i) const throw ()
reference | operator[] (int i) const throw ()
reference | operator[] (const char[]) const
reference | operator[] (const PGSTD::string &s) const
reference | at (size_type) const throw (PGSTD::out_of_range)
reference | at (int i) const throw (PGSTD::out_of_range)
reference | at (const char[]) const
reference | at (const PGSTD::string &s) const
Column information
size_type | column_number (const PGSTD::string &ColName) const
| Number of given column (throws exception if it doesn't exist).
size_type | column_number (const char ColName[]) const
| Number of given column (throws exception if it doesn't exist).
oid | column_type (size_type ColNum) const
| Type of given column.
oid | column_type (int ColNum) const
| Type of given column.
oid | column_type (const PGSTD::string &ColName) const
| Type of given column.
oid | column_type (const char ColName[]) const
| Type of given column.
oid | column_table (size_type ColNum) const
| What table did this column come from? Requires PostgreSQL 7.4 C API.
oid | column_table (int ColNum) const
| What table did this column come from? Requires PostgreSQL 7.4 C API.
oid | column_table (const PGSTD::string &ColName) const
| What table did this column come from? Requires PostgreSQL 7.4 C API.
size_type | table_column (size_type ColNum) const
| What column number in its table did this result column come from?
size_type | table_column (int ColNum) const
| What column number in its table did this result column come from?
size_type | table_column (const PGSTD::string &ColName) const
| What column number in its table did this result column come from?

## Protected Member Functions

| tuple ()

## Protected Attributes

const result * | m_Home
result::size_type | m_Index

## Friends

class | field

## Detailed Description

Reference to one row in a result.

A tuple represents one row (also called a tuple) in a query result set. It also acts as a container mapping column numbers or names to field values (see below):

            cout << tuple["date"].c_str() << ": " << tuple["name"].c_str() << endl;

The tuple itself acts like a (non-modifyable) container, complete with its own const_iterator and const_reverse_iterator.

## Member Typedef Documentation

typedef unsigned int pqxx::result::tuple::size_type

Reimplemented in pqxx::result::const_iterator.

typedef signed int pqxx::result::tuple::difference_type

Reimplemented in pqxx::result::const_iterator.

typedef const_fielditerator pqxx::result::tuple::const_iterator

typedef field pqxx::result::tuple::reference

Reimplemented in pqxx::result::const_iterator.

typedef const_fielditerator pqxx::result::tuple::pointer

Reimplemented in pqxx::result::const_iterator.

typedef const_reverse_fielditerator pqxx::result::tuple::const_reverse_iterator

## Constructor & Destructor Documentation

pqxx::result::tuple::tuple | ( | const result * | r,
|  | result::size_type | i |
| ) |  |  | throw ()

pqxx::result::tuple::~tuple | ( |  | ) | throw ()

pqxx::result::tuple::tuple | ( |  | ) | `[protected]`

## Member Function Documentation

bool pqxx::result::tuple::operator== | ( | const tuple & |  | ) | const throw ()

bool pqxx::result::tuple::operator!= | ( | const tuple & | rhs | ) | const throw ()

const_iterator pqxx::result::tuple::begin | ( |  | ) | const throw ()

const_iterator pqxx::result::tuple::end | ( |  | ) | const throw ()

reference pqxx::result::tuple::front | ( |  | ) | const throw ()

reference pqxx::result::tuple::back | ( |  | ) | const throw ()

result::tuple::const_reverse_iterator pqxx::result::tuple::rbegin | ( |  | ) | const

result::tuple::const_reverse_iterator pqxx::result::tuple::rend | ( |  | ) | const

reference pqxx::result::tuple::operator[] | ( | size_type | i | ) | const throw ()

reference pqxx::result::tuple::operator[] | ( | int | i | ) | const throw ()

pqxx::result::field pqxx::result::tuple::operator[] | ( | const | char[] | ) | const

reference pqxx::result::tuple::operator[] | ( | const PGSTD::string & | s | ) | const

pqxx::result::field pqxx::result::tuple::at | ( | size_type |  | ) | const throw (PGSTD::out_of_range)

reference pqxx::result::tuple::at | ( | int | i | ) | const throw (PGSTD::out_of_range)

pqxx::result::field pqxx::result::tuple::at | ( | const | char[] | ) | const

reference pqxx::result::tuple::at | ( | const PGSTD::string & | s | ) | const

size_type pqxx::result::tuple::size | ( |  | ) | const throw ()

void pqxx::result::tuple::swap | ( | tuple & |  | ) | throw ()

result::size_type pqxx::result::tuple::rownumber | ( |  | ) | const throw ()

size_type pqxx::result::tuple::column_number | ( | const PGSTD::string & | ColName | ) | const

Number of given column (throws exception if it doesn't exist).

size_type pqxx::result::tuple::column_number | ( | const char | ColName[] | ) | const

Number of given column (throws exception if it doesn't exist).

oid pqxx::result::tuple::column_type | ( | size_type | ColNum | ) | const

Type of given column.

oid pqxx::result::tuple::column_type | ( | int | ColNum | ) | const

Type of given column.

oid pqxx::result::tuple::column_type | ( | const PGSTD::string & | ColName | ) | const

Type of given column.

oid pqxx::result::tuple::column_type | ( | const char | ColName[] | ) | const

Type of given column.

oid pqxx::result::tuple::column_table | ( | size_type | ColNum | ) | const

What table did this column come from? Requires PostgreSQL 7.4 C API.

Only defined if the libpqxx library was compiled against a libpq version that supports the `PQftable` function.

If you get a link error saying this function is undefined, that must be because libpqxx was compiled against an older version of libpq. The `PQftable` function first became available in PostgreSQL 7.4.

oid pqxx::result::tuple::column_table | ( | int | ColNum | ) | const

What table did this column come from? Requires PostgreSQL 7.4 C API.

Only defined if the libpqxx library was compiled against a libpq version that supports the `PQftable` function.

If you get a link error saying this function is undefined, that must be because libpqxx was compiled against an older version of libpq. The `PQftable` function first became available in PostgreSQL 7.4.

oid pqxx::result::tuple::column_table | ( | const PGSTD::string & | ColName | ) | const

What table did this column come from? Requires PostgreSQL 7.4 C API.

Only defined if the libpqxx library was compiled against a libpq version that supports the `PQftable` function.

If you get a link error saying this function is undefined, that must be because libpqxx was compiled against an older version of libpq. The `PQftable` function first became available in PostgreSQL 7.4.

size_type pqxx::result::tuple::table_column | ( | size_type | ColNum | ) | const

What column number in its table did this result column come from?

A meaningful answer can be given only if the column in question comes directly from a column in a table. If the column is computed in any other way, a logic_error will be thrown.

Parameters:

  | ColNum | a zero-based column number in this result set

Returns:
  a zero-based column number in originating table

Requires libpq from PostgreSQL 7.4 or better, as well as a server version of at least 7.4.

size_type pqxx::result::tuple::table_column | ( | int | ColNum | ) | const

What column number in its table did this result column come from?

size_type pqxx::result::tuple::table_column | ( | const PGSTD::string & | ColName | ) | const

What column number in its table did this result column come from?

result::size_type pqxx::result::tuple::num | ( |  | ) | const

## Friends And Related Function Documentation

friend class field `[friend]`

## Member Data Documentation

const result* pqxx::result::tuple::m_Home `[protected]`

result::size_type pqxx::result::tuple::m_Index `[protected]`

The documentation for this class was generated from the following files:

- result.hxx
- result.cxx